object InputLoop {

  def create ():InputLoop = new InputLoopImpl

  private class InputLoopImpl extends InputLoop {

    private var subscribers:List[Subscriber[String]] = 
      List.empty()

    def subscribe (sub:Subscriber[String]):Unit = {
        subscribers = List.cons(sub,subscribers)
    }

    def publish (data:String):Unit = {

      // syntactic sugar for calling the 'foreach' method in List!
      for (sub:Subscriber[String] <- subscribers) {
        sub.notify(data)
      }
    }

    def loop ():Unit = {

      val s:String = readLine("> ")
      publish(s)
      loop()
    }
  }
}


abstract class InputLoop extends Publisher[String] {

  def loop ():Unit
}
